
/* sema.h
   Semaphore manifests.
 */

/* semaphore message types */
#define SEMA_ADD_TO_LIST     	  1
#define SEMA_RELEASE_FROM_LIST	  2

/* semaphore notify methods */
#define SEMA_REPLY_TO_ME          1
#define SEMA_SIGNAL_ME            2

/* semaphore return message codes */
#define SEMA_OK                   0
#define SEMA_BAD_MSG     		 -1
#define SEMA_NO_ENTRIES          -2
#define SEMA_SEND_FAILURE        -3

/*
 * All semaphore messages have this structure
 */
struct sema_msg_entry {
    signed char msg_type;    /* message types */
    int    notify_method;    /* REPLY_TO_ME or SIGNAL_ME */	
    int    signal;           /* used if notify_method == SIGNAL_ME */
    int    priority;         /* priority of semaphore request. 0 = lowest */
    nid_t  node;	     /* node of requester */
    pid_t  pid;		     /* pid of requester */
	};

int sema_request( pid_t, int, int, int, int );
int sema_manager( char * );

