
/*   semalib.c
     Semaphore library routines.
 */

#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <errno.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/osinfo.h>
#include <sys/vc.h>
#include <unistd.h>
#include "sema.h"

int sema_request( pid_t sema_manager, int action, int notify_type,
                  int signal, int priority )
{
struct sema_msg_entry msg;

  msg.msg_type      = action;
  msg.notify_method = notify_type;
  msg.signal        = signal;
  msg.priority      = priority;
  msg.node	    = getnid();
  msg.pid	    = getpid();
  
  if ( Send( sema_manager, &msg, &msg, sizeof (struct sema_msg_entry), 
             sizeof (struct sema_msg_entry) ) == -1 ) {
     return(SEMA_SEND_FAILURE);
     }
  return(msg.msg_type);
}

int sema_manager( char *sema_name )
{
  pid_t sema4pid;
  #define DEFAULT_SEMA_NAME  "qnx/sema1"

  sema4pid = qnx_name_locate( 0, 
                  (sema_name == NULL) ? DEFAULT_SEMA_NAME : sema_name,
                  0, NULL );
  return( sema4pid );
}

