
/* semasig.c
   Semaphore test program showing use of signals.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include <errno.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/osinfo.h>
#include <sys/vc.h>
#include <unistd.h>
#include <signal.h>
#include <setjmp.h>
#include "sema.h"

pid_t sema4pid;
sigjmp_buf env;

#define MY_SIGNAL  SIGUSR1

void sema_handler() {
   siglongjmp( env, 1 );
   }

int i=0;

main()
{
int ret;

signal( MY_SIGNAL, sema_handler );

sema4pid = sema_manager( NULL );
if ( sema4pid == -1 ) {
   printf("Can't find manager. %s.\n", strerror(errno));
   exit(-1);
   }

  /* we'll return here when we are signalled */
  ret = 293;   /* set to any non-zero value */
  ret = sigsetjmp( env, 1 );

  switch ( ret ) {
       case 0:   /* doing the initial setjmp */
                 break;
       default:  /* got back from longjmp, we have the semaphore */
                 /* now use whatever we want to use the semaphore for */
                 /* when we're done, release the semaphore */
                 if ( i++ >= 1000 ) exit(0);   /* exit after 1000 semaphore signals */
                 switch ( sema_request( sema4pid, SEMA_RELEASE_FROM_LIST,
                                        0, 0, 0) ) {
                      case SEMA_SEND_FAILURE: printf("Send Failure: %s.\n", strerror(errno));
                                              exit(-1);
                                              break;
                      case SEMA_NO_ENTRIES:   printf("No more semaphore entries.\n");
                                              exit(-1);
                                              break;
                      case SEMA_OK:           break;
                      }
                 break;
       }

  /* tell the semaphore manager we want to be signalled when we can use the */
  /* semaphore */
  switch ( sema_request( sema4pid, SEMA_ADD_TO_LIST, SEMA_SIGNAL_ME,
                         MY_SIGNAL, 0) ) {
      case SEMA_SEND_FAILURE: printf("Send Failure: %s.\n", strerror(errno));
                              exit(-1);
                              break;
      case SEMA_NO_ENTRIES:   printf("No more semaphore entries.\n");
                              exit(-1);
                              break;
      case SEMA_OK:           break;
      }

  /* at this point we can do regular work until our signal comes in */
  /* remember that we can be signalled at any time */
  while ( 1 ) {
     sleep(5000);
     }
}


