
/* semas.c
   Semaphore test program.
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <string.h>
#include <errno.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/osinfo.h>
#include <sys/vc.h>
#include <unistd.h>
#include "sema.h"

main()
{
int i = 0;
pid_t sema4pid;

fork();  /* duplicate so there are two processes sharing the semaphore */

sema4pid = sema_manager( NULL );
if ( sema4pid == -1 ) {
   printf("Can't find manager. %s\n", strerror(errno));
   exit(-1);
   }

while(i++ < 1000 ) {
  switch ( sema_request( sema4pid, SEMA_ADD_TO_LIST, SEMA_REPLY_TO_ME, 0, 0) ) {
      case SEMA_SEND_FAILURE: printf("Send Failure: %s\n", strerror(errno));
                              exit(-1);
                              break;
      case SEMA_NO_ENTRIES:   printf("No more semaphore entries.\n");
                              exit(-1);
                              break;
      case SEMA_OK:           break;
      }

  /* Now we have the semaphore. Do what we want at this point. */
  /* Use the device etc....  */

  switch ( sema_request( sema4pid, SEMA_RELEASE_FROM_LIST, 0, 0, 0) ) {
      case SEMA_SEND_FAILURE: printf("Send Failure: %s\n", strerror(errno));
                              exit(-1);
                              break;
      case SEMA_NO_ENTRIES:   printf("No more semaphore entries.\n");
                              exit(-1);
                              break;
      case SEMA_OK:           break;
      }
  }
}

